igeo

## Class IBox

- java.lang.Object
- - igeo.IObject
  - - igeo.IGeometry
    - - igeo.IBrep
      - - igeo.IBox

- All Implemented Interfaces:
    ITransformable

      public class IBox
      extends IBrep

  Box geometry
  Author:
    Satoru Sugihara

- - ### Field Summary

    - ### Fields inherited from class igeo.IBrep

      `solid, surfaces`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IBox(double x, double y, double z, double size)` object methods
    `IBox(double x, double y, double z, double w, double h, double d)`
    `IBox(IBox box)`
    `IBox(IServerI s, double x, double y, double z, double size)`
    `IBox(IServerI s, double x, double y, double z, double w, double h, double d)`
    `IBox(IServerI s, IBox box)`
    `IBox(IServerI s, IVecI[][][] corners)`
    `IBox(IServerI s, IVecI origin, double size)`
    `IBox(IServerI s, IVecI origin, double width, double height, double depth)`
    `IBox(IServerI s, IVecI origin, IVecI xvec, IVecI yvec, IVecI zvec)`
    `IBox(IServerI s, IVecI pt1, IVecI pt2, IVecI pt3, IVecI pt4, IVecI pt5, IVecI pt6, IVecI pt7, IVecI pt8)` order of points in the argument is going round at the bottom and going round at the top
    `IBox(IVecI[][][] corners)`
    `IBox(IVecI origin, double size)`
    `IBox(IVecI origin, double width, double height, double depth)`
    `IBox(IVecI origin, IVecI xvec, IVecI yvec, IVecI zvec)`
    `IBox(IVecI pt1, IVecI pt2, IVecI pt3, IVecI pt4, IVecI pt5, IVecI pt6, IVecI pt7, IVecI pt8)` order of points in the argument is going round at the bottom and going round at the top

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IBox` | `add(double x, double y, double z)` implementation of ITransformable interface
    `IBox` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBox` | `add(IVecI v)`
    `IBox` | `add(IVecI v, double f)` scale add
    `IBox` | `add(IVecI v, IDoubleI f)` scale add
    `IBox` | `clr(java.awt.Color c)`
    `IBox` | `clr(java.awt.Color c, int alpha)`
    `IBox` | `clr(double dgray)`
    `IBox` | `clr(double dgray, double dalpha)`
    `IBox` | `clr(double dr, double dg, double db)`
    `IBox` | `clr(double dr, double dg, double db, double da)`
    `IBox` | `clr(float fgray)`
    `IBox` | `clr(float fgray, float falpha)`
    `IBox` | `clr(float fr, float fg, float fb)`
    `IBox` | `clr(float fr, float fg, float fb, float fa)`
    `IBox` | `clr(IColor c)` to set an object color
    `IBox` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
    `IBox` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
    `IBox` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
    `IBox` | `clr(int gray)`
    `IBox` | `clr(int gray, int alpha)`
    `IBox` | `clr(int r, int g, int b)`
    `IBox` | `clr(int r, int g, int b, int a)`
    `IBox` | `clr(IObject o)` to set the same color with the object
    `IBox` | `cp()` cp() is alias of dup()
    `IBox` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IBox` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBox` | `cp(IVecI v)`
    `IBox` | `div(double v)`
    `IBox` | `div(IDoubleI v)`
    `IBox` | `dup()` duplicate object
    `IBox` | `flip()` alias of neg
    `static ISurfaceGeo[]` | `getBoxFaces(IVecI[][][] corners)` static methods
    `IBox` | `hide()`
    `IBox` | `hsb(double h, double s, double b)`
    `IBox` | `hsb(double h, double s, double b, double a)`
    `IBox` | `hsb(float h, float s, float b)`
    `IBox` | `hsb(float h, float s, float b, float a)`
    `IBox` | `layer(ILayer l)` Set layer by ILayer object
    `IBox` | `mirror(IVecI planeDir)` mirror is alias of ref
    `IBox` | `mirror(IVecI center, IVecI planeDir)`
    `IBox` | `mul(double v)`
    `IBox` | `mul(IDoubleI v)`
    `IBox` | `mv(double x, double y, double z)` mv() is alias of add()
    `IBox` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBox` | `mv(IVecI v)`
    `IBox` | `name(java.lang.String nm)`
    `IBox` | `neg()`
    `IBox` | `ref(IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IBox` | `ref(IVecI center, IVecI planeDir)`
    `IBox` | `rot(IVecI axis, double angle)`
    `IBox` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IBox` | `rot(IVecI axis, IVecI destDir)` rotate to destination direction vector
    `IBox` | `rot(IVecI center, IVecI axis, double angle)`
    `IBox` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center
    `IBox` | `rot(IVecI center, IVecI axis, IVecI destPt)` rotate to destination point location
    `IBox` | `scale(double f)`
    `IBox` | `scale(IDoubleI f)` alias of mul
    `IBox` | `scale(IVecI center, double f)`
    `IBox` | `scale(IVecI center, IDoubleI f)`
    `IBox` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IBox` | `scale1d(IVecI axis, IDoubleI f)`
    `IBox` | `scale1d(IVecI center, IVecI axis, double f)`
    `IBox` | `scale1d(IVecI center, IVecI axis, IDoubleI f)`
    `IBox` | `setColor(java.awt.Color c)`
    `IBox` | `setColor(java.awt.Color c, int alpha)`
    `IBox` | `setColor(double dgray)`
    `IBox` | `setColor(double dgray, double dalpha)`
    `IBox` | `setColor(double dr, double dg, double db)`
    `IBox` | `setColor(double dr, double dg, double db, double da)`
    `IBox` | `setColor(float fgray)`
    `IBox` | `setColor(float fr, float fg, float fb)`
    `IBox` | `setColor(float fr, float fg, float fb, float fa)`
    `IBox` | `setColor(float fgray, int falpha)`
    `IBox` | `setColor(int gray)`
    `IBox` | `setColor(int gray, int alpha)`
    `IBox` | `setColor(int r, int g, int b)`
    `IBox` | `setColor(int r, int g, int b, int a)`
    `IBox` | `setHSBColor(double h, double s, double b)`
    `IBox` | `setHSBColor(double h, double s, double b, double a)`
    `IBox` | `setHSBColor(float h, float s, float b)`
    `IBox` | `setHSBColor(float h, float s, float b, float a)`
    `IBox` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IBox` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IBox` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)`
    `IBox` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IBox` | `shearXY(double sxy, double syx)`
    `IBox` | `shearXY(IDoubleI sxy, IDoubleI syx)`
    `IBox` | `shearXY(IVecI center, double sxy, double syx)`
    `IBox` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)`
    `IBox` | `shearYZ(double syz, double szy)`
    `IBox` | `shearYZ(IDoubleI syz, IDoubleI szy)`
    `IBox` | `shearYZ(IVecI center, double syz, double szy)`
    `IBox` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)`
    `IBox` | `shearZX(double szx, double sxz)`
    `IBox` | `shearZX(IDoubleI szx, IDoubleI sxz)`
    `IBox` | `shearZX(IVecI center, double szx, double sxz)`
    `IBox` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)`
    `IBox` | `show()`
    `IBox` | `sub(double x, double y, double z)`
    `IBox` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBox` | `sub(IVecI v)`
    `IBox` | `transform(IMatrix3I mat)`
    `IBox` | `transform(IMatrix4I mat)`
    `IBox` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)`
    `IBox` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)`
    `IBox` | `translate(double x, double y, double z)` translate() is alias of add()
    `IBox` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBox` | `translate(IVecI v)`
    `IBox` | `weight(double w)`
    `IBox` | `weight(float w)`

    - ### Methods inherited from class igeo.IBrep

      `add, add, attr, center, checkDuplicatedPoints, clr, clr, createGraphic, initBrep, initBrepWithCurve, initBrepWithPoint, initBrepWithSurface, initBrepWithSurfaceGeo, isValid, layer, rot, rot, rot2, rot2, rot2, rot2, rot2, rot2, setColor, setColor, setColor, setColor, setColor, setColor, surface, surfaceNum, surfaces`

    - ### Methods inherited from class igeo.IGeometry

      `setColor`

    - ### Methods inherited from class igeo.IObject

      `addDynamics, addUserData, addUserData, alpha, alphaInt, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, defaultAttribute, del, deletDynamics, deleteDynamics, deleteDynamics, deleteGraphic, dynamicsNum, getAWTColor, getColor, getDynamics, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isVisible, layer, name, red, redInt, resetGraphic, saturation, server, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, updateGraphic, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IBox

          public IBox(double x,
                      double y,
                      double z,
                      double size)

      object methods

    - #### IBox

          public IBox(double x,
                      double y,
                      double z,
                      double w,
                      double h,
                      double d)

    - #### IBox

          public IBox(IVecI origin,
                      double size)

    - #### IBox

          public IBox(IVecI origin,
                      double width,
                      double height,
                      double depth)

    - #### IBox

          public IBox(IVecI origin,
                      IVecI xvec,
                      IVecI yvec,
                      IVecI zvec)

    - #### IBox

          public IBox(IVecI pt1,
                      IVecI pt2,
                      IVecI pt3,
                      IVecI pt4,
                      IVecI pt5,
                      IVecI pt6,
                      IVecI pt7,
                      IVecI pt8)

      order of points in the argument is going round at the bottom and going round at the top

    - #### IBox

          public IBox(IVecI[][][] corners)

    - #### IBox

          public IBox(IServerI s,
                      double x,
                      double y,
                      double z,
                      double size)

    - #### IBox

          public IBox(IServerI s,
                      double x,
                      double y,
                      double z,
                      double w,
                      double h,
                      double d)

    - #### IBox

          public IBox(IServerI s,
                      IVecI origin,
                      double size)

    - #### IBox

          public IBox(IServerI s,
                      IVecI origin,
                      double width,
                      double height,
                      double depth)

    - #### IBox

          public IBox(IServerI s,
                      IVecI origin,
                      IVecI xvec,
                      IVecI yvec,
                      IVecI zvec)

    - #### IBox

          public IBox(IServerI s,
                      IVecI pt1,
                      IVecI pt2,
                      IVecI pt3,
                      IVecI pt4,
                      IVecI pt5,
                      IVecI pt6,
                      IVecI pt7,
                      IVecI pt8)

      order of points in the argument is going round at the bottom and going round at the top

    - #### IBox

          public IBox(IServerI s,
                      IVecI[][][] corners)

    - #### IBox

          public IBox(IBox box)

    - #### IBox

          public IBox(IServerI s,
                      IBox box)

  - ### Method Detail

    - #### getBoxFaces

          public static ISurfaceGeo[] getBoxFaces(IVecI[][][] corners)

      static methods

    - #### dup

          public IBox dup()

      Description copied from class: `IObject`
      duplicate object
      Specified by:
        `dup` in interface `ITransformable`
      Overrides:
        `dup` in class `IBrep`

    - #### name

          public IBox name(java.lang.String nm)

      Overrides:
        `name` in class `IBrep`

    - #### layer

          public IBox layer(ILayer l)

      Description copied from class: `IGeometry`
      Set layer by ILayer object
      Overrides:
        `layer` in class `IBrep`

    - #### hide

          public IBox hide()

      Overrides:
        `hide` in class `IBrep`

    - #### show

          public IBox show()

      Overrides:
        `show` in class `IBrep`

    - #### clr

          public IBox clr(IColor c)

      Description copied from class: `IObject`
      to set an object color
      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(IColor c,
                          int alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(IColor c,
                          float alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(IColor c,
                          double alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(IObject o)

      Description copied from class: `IObject`
      to set the same color with the object
      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(java.awt.Color c)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(java.awt.Color c,
                          int alpha)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(int gray)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(float fgray)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(double dgray)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(int gray,
                          int alpha)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(float fgray,
                          float falpha)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(double dgray,
                          double dalpha)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(int r,
                          int g,
                          int b)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(float fr,
                          float fg,
                          float fb)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(double dr,
                          double dg,
                          double db)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(int r,
                          int g,
                          int b,
                          int a)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(float fr,
                          float fg,
                          float fb,
                          float fa)

      Overrides:
        `clr` in class `IBrep`

    - #### clr

          public IBox clr(double dr,
                          double dg,
                          double db,
                          double da)

      Overrides:
        `clr` in class `IBrep`

    - #### hsb

          public IBox hsb(float h,
                          float s,
                          float b,
                          float a)

      Overrides:
        `hsb` in class `IBrep`

    - #### hsb

          public IBox hsb(double h,
                          double s,
                          double b,
                          double a)

      Overrides:
        `hsb` in class `IBrep`

    - #### hsb

          public IBox hsb(float h,
                          float s,
                          float b)

      Overrides:
        `hsb` in class `IBrep`

    - #### hsb

          public IBox hsb(double h,
                          double s,
                          double b)

      Overrides:
        `hsb` in class `IBrep`

    - #### setColor

          public IBox setColor(java.awt.Color c)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(java.awt.Color c,
                               int alpha)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(int gray)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(float fgray)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(double dgray)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(int gray,
                               int alpha)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(float fgray,
                               int falpha)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(double dgray,
                               double dalpha)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(int r,
                               int g,
                               int b)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(float fr,
                               float fg,
                               float fb)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(double dr,
                               double dg,
                               double db)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(int r,
                               int g,
                               int b,
                               int a)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(float fr,
                               float fg,
                               float fb,
                               float fa)

      Overrides:
        `setColor` in class `IBrep`

    - #### setColor

          public IBox setColor(double dr,
                               double dg,
                               double db,
                               double da)

      Overrides:
        `setColor` in class `IBrep`

    - #### setHSBColor

          public IBox setHSBColor(float h,
                                  float s,
                                  float b,
                                  float a)

      Overrides:
        `setHSBColor` in class `IBrep`

    - #### setHSBColor

          public IBox setHSBColor(double h,
                                  double s,
                                  double b,
                                  double a)

      Overrides:
        `setHSBColor` in class `IBrep`

    - #### setHSBColor

          public IBox setHSBColor(float h,
                                  float s,
                                  float b)

      Overrides:
        `setHSBColor` in class `IBrep`

    - #### setHSBColor

          public IBox setHSBColor(double h,
                                  double s,
                                  double b)

      Overrides:
        `setHSBColor` in class `IBrep`

    - #### weight

          public IBox weight(double w)

      Overrides:
        `weight` in class `IBrep`

    - #### weight

          public IBox weight(float w)

      Overrides:
        `weight` in class `IBrep`

    - #### add

          public IBox add(double x,
                          double y,
                          double z)

      implementation of ITransformable interface
      Specified by:
        `add` in interface `ITransformable`
      Overrides:
        `add` in class `IBrep`

    - #### add

          public IBox add(IDoubleI x,
                          IDoubleI y,
                          IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Overrides:
        `add` in class `IBrep`

    - #### add

          public IBox add(IVecI v)

      Specified by:
        `add` in interface `ITransformable`
      Overrides:
        `add` in class `IBrep`

    - #### sub

          public IBox sub(double x,
                          double y,
                          double z)

      Specified by:
        `sub` in interface `ITransformable`
      Overrides:
        `sub` in class `IBrep`

    - #### sub

          public IBox sub(IDoubleI x,
                          IDoubleI y,
                          IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Overrides:
        `sub` in class `IBrep`

    - #### sub

          public IBox sub(IVecI v)

      Specified by:
        `sub` in interface `ITransformable`
      Overrides:
        `sub` in class `IBrep`

    - #### mul

          public IBox mul(IDoubleI v)

      Specified by:
        `mul` in interface `ITransformable`
      Overrides:
        `mul` in class `IBrep`

    - #### mul

          public IBox mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Overrides:
        `mul` in class `IBrep`

    - #### div

          public IBox div(IDoubleI v)

      Specified by:
        `div` in interface `ITransformable`
      Overrides:
        `div` in class `IBrep`

    - #### div

          public IBox div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Overrides:
        `div` in class `IBrep`

    - #### neg

          public IBox neg()

      Specified by:
        `neg` in interface `ITransformable`
      Overrides:
        `neg` in class `IBrep`

    - #### flip

          public IBox flip()

      alias of neg
      Specified by:
        `flip` in interface `ITransformable`
      Overrides:
        `flip` in class `IBrep`

    - #### add

          public IBox add(IVecI v,
                          double f)

      scale add
      Specified by:
        `add` in interface `ITransformable`
      Overrides:
        `add` in class `IBrep`

    - #### add

          public IBox add(IVecI v,
                          IDoubleI f)

      Description copied from class: `IGeometry`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Overrides:
        `add` in class `IBrep`

    - #### rot

          public IBox rot(IVecI axis,
                          IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Overrides:
        `rot` in class `IBrep`

    - #### rot

          public IBox rot(IVecI axis,
                          double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Overrides:
        `rot` in class `IBrep`

    - #### rot

          public IBox rot(IVecI center,
                          IVecI axis,
                          IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around axis vector and center
      Specified by:
        `rot` in interface `ITransformable`
      Overrides:
        `rot` in class `IBrep`

    - #### rot

          public IBox rot(IVecI center,
                          IVecI axis,
                          double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Overrides:
        `rot` in class `IBrep`

    - #### rot

          public IBox rot(IVecI axis,
                          IVecI destDir)

      rotate to destination direction vector
      Specified by:
        `rot` in interface `ITransformable`
      Overrides:
        `rot` in class `IBrep`

    - #### rot

          public IBox rot(IVecI center,
                          IVecI axis,
                          IVecI destPt)

      rotate to destination point location
      Specified by:
        `rot` in interface `ITransformable`
      Overrides:
        `rot` in class `IBrep`

    - #### scale

          public IBox scale(IDoubleI f)

      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Overrides:
        `scale` in class `IBrep`

    - #### scale

          public IBox scale(double f)

      Specified by:
        `scale` in interface `ITransformable`
      Overrides:
        `scale` in class `IBrep`

    - #### scale

          public IBox scale(IVecI center,
                            IDoubleI f)

      Specified by:
        `scale` in interface `ITransformable`
      Overrides:
        `scale` in class `IBrep`

    - #### scale

          public IBox scale(IVecI center,
                            double f)

      Specified by:
        `scale` in interface `ITransformable`
      Overrides:
        `scale` in class `IBrep`

    - #### scale1d

          public IBox scale1d(IVecI axis,
                              double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Overrides:
        `scale1d` in class `IBrep`

    - #### scale1d

          public IBox scale1d(IVecI axis,
                              IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Overrides:
        `scale1d` in class `IBrep`

    - #### scale1d

          public IBox scale1d(IVecI center,
                              IVecI axis,
                              double f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Overrides:
        `scale1d` in class `IBrep`

    - #### scale1d

          public IBox scale1d(IVecI center,
                              IVecI axis,
                              IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Overrides:
        `scale1d` in class `IBrep`

    - #### ref

          public IBox ref(IVecI planeDir)

      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Overrides:
        `ref` in class `IBrep`

    - #### ref

          public IBox ref(IVecI center,
                          IVecI planeDir)

      Specified by:
        `ref` in interface `ITransformable`
      Overrides:
        `ref` in class `IBrep`

    - #### mirror

          public IBox mirror(IVecI planeDir)

      mirror is alias of ref
      Specified by:
        `mirror` in interface `ITransformable`
      Overrides:
        `mirror` in class `IBrep`

    - #### mirror

          public IBox mirror(IVecI center,
                             IVecI planeDir)

      Specified by:
        `mirror` in interface `ITransformable`
      Overrides:
        `mirror` in class `IBrep`

    - #### shear

          public IBox shear(double sxy,
                            double syx,
                            double syz,
                            double szy,
                            double szx,
                            double sxz)

      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Overrides:
        `shear` in class `IBrep`

    - #### shear

          public IBox shear(IDoubleI sxy,
                            IDoubleI syx,
                            IDoubleI syz,
                            IDoubleI szy,
                            IDoubleI szx,
                            IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Overrides:
        `shear` in class `IBrep`

    - #### shear

          public IBox shear(IVecI center,
                            double sxy,
                            double syx,
                            double syz,
                            double szy,
                            double szx,
                            double sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Overrides:
        `shear` in class `IBrep`

    - #### shear

          public IBox shear(IVecI center,
                            IDoubleI sxy,
                            IDoubleI syx,
                            IDoubleI syz,
                            IDoubleI szy,
                            IDoubleI szx,
                            IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Overrides:
        `shear` in class `IBrep`

    - #### shearXY

          public IBox shearXY(double sxy,
                              double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Overrides:
        `shearXY` in class `IBrep`

    - #### shearXY

          public IBox shearXY(IDoubleI sxy,
                              IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Overrides:
        `shearXY` in class `IBrep`

    - #### shearXY

          public IBox shearXY(IVecI center,
                              double sxy,
                              double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Overrides:
        `shearXY` in class `IBrep`

    - #### shearXY

          public IBox shearXY(IVecI center,
                              IDoubleI sxy,
                              IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Overrides:
        `shearXY` in class `IBrep`

    - #### shearYZ

          public IBox shearYZ(double syz,
                              double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Overrides:
        `shearYZ` in class `IBrep`

    - #### shearYZ

          public IBox shearYZ(IDoubleI syz,
                              IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Overrides:
        `shearYZ` in class `IBrep`

    - #### shearYZ

          public IBox shearYZ(IVecI center,
                              double syz,
                              double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Overrides:
        `shearYZ` in class `IBrep`

    - #### shearYZ

          public IBox shearYZ(IVecI center,
                              IDoubleI syz,
                              IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Overrides:
        `shearYZ` in class `IBrep`

    - #### shearZX

          public IBox shearZX(double szx,
                              double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Overrides:
        `shearZX` in class `IBrep`

    - #### shearZX

          public IBox shearZX(IDoubleI szx,
                              IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Overrides:
        `shearZX` in class `IBrep`

    - #### shearZX

          public IBox shearZX(IVecI center,
                              double szx,
                              double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Overrides:
        `shearZX` in class `IBrep`

    - #### shearZX

          public IBox shearZX(IVecI center,
                              IDoubleI szx,
                              IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Overrides:
        `shearZX` in class `IBrep`

    - #### mv

          public IBox mv(double x,
                         double y,
                         double z)

      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Overrides:
        `mv` in class `IBrep`

    - #### mv

          public IBox mv(IDoubleI x,
                         IDoubleI y,
                         IDoubleI z)

      Specified by:
        `mv` in interface `ITransformable`
      Overrides:
        `mv` in class `IBrep`

    - #### mv

          public IBox mv(IVecI v)

      Specified by:
        `mv` in interface `ITransformable`
      Overrides:
        `mv` in class `IBrep`

    - #### cp

          public IBox cp()

      cp() is alias of dup()
      Specified by:
        `cp` in interface `ITransformable`
      Overrides:
        `cp` in class `IBrep`

    - #### cp

          public IBox cp(double x,
                         double y,
                         double z)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Overrides:
        `cp` in class `IBrep`

    - #### cp

          public IBox cp(IDoubleI x,
                         IDoubleI y,
                         IDoubleI z)

      Specified by:
        `cp` in interface `ITransformable`
      Overrides:
        `cp` in class `IBrep`

    - #### cp

          public IBox cp(IVecI v)

      Specified by:
        `cp` in interface `ITransformable`
      Overrides:
        `cp` in class `IBrep`

    - #### translate

          public IBox translate(double x,
                                double y,
                                double z)

      translate() is alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Overrides:
        `translate` in class `IBrep`

    - #### translate

          public IBox translate(IDoubleI x,
                                IDoubleI y,
                                IDoubleI z)

      Specified by:
        `translate` in interface `ITransformable`
      Overrides:
        `translate` in class `IBrep`

    - #### translate

          public IBox translate(IVecI v)

      Specified by:
        `translate` in interface `ITransformable`
      Overrides:
        `translate` in class `IBrep`

    - #### transform

          public IBox transform(IMatrix3I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Overrides:
        `transform` in class `IBrep`

    - #### transform

          public IBox transform(IMatrix4I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Overrides:
        `transform` in class `IBrep`

    - #### transform

          public IBox transform(IVecI xvec,
                                IVecI yvec,
                                IVecI zvec)

      Specified by:
        `transform` in interface `ITransformable`
      Overrides:
        `transform` in class `IBrep`

    - #### transform

          public IBox transform(IVecI xvec,
                                IVecI yvec,
                                IVecI zvec,
                                IVecI translate)

      Specified by:
        `transform` in interface `ITransformable`
      Overrides:
        `transform` in class `IBrep`